/*
  File autogenerated by gengetopt version 2.10
  generated with the following command:
  gengetopt

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "getopt.h"

#include "cmdline.h"

void
cmdline_parser_print_version (void)
{
  printf ("%s %s\n", CMDLINE_PARSER_PACKAGE, CMDLINE_PARSER_VERSION);
}

void
cmdline_parser_print_help (void)
{
  cmdline_parser_print_version ();
  printf ("\n" "Usage: %s [OPTIONS]...\n", CMDLINE_PARSER_PACKAGE);
  printf ("   -h         --help               Print help and exit\n");
  printf ("   -V         --version            Print version and exit\n");
  printf ("   -iSTRING   --virtual-if=STRING  virtual interface\n");
  printf
    ("   -aSTRING   --virtual-ip=STRING  your virtual gateway ip address\n");
  printf
    ("   -bSTRING   --virtual-netmask=STRING  virtual interface netmask\n");
  printf
    ("   -nSTRING   --virtual-broadcast=STRING  virtual interface broadcast address\n");
  printf ("   -gINT      --group=INT          vgp group\n");
  printf ("   -pINT      --priority=INT       vgp priority\n");
  printf ("   -lSTRING   --log=STRING         syslog facility\n");
  printf ("   -tINT      --hello-time=INT     vgp hello-time\n");
  printf ("   -d         --debug              debug\n");
}


static char *gengetopt_strdup (const char *s);

/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = (char *) malloc (strlen (s) + 1);
  if (result == (char *) 0)
    return (char *) 0;
  strcpy (result, s);
  return result;
}

int
cmdline_parser (int argc, char *const *argv,
		struct gengetopt_args_info *args_info)
{
  int c;			/* Character of the parsed option.  */
  int missing_required_options = 0;

  args_info->help_given = 0;
  args_info->version_given = 0;
  args_info->virtual_if_given = 0;
  args_info->virtual_ip_given = 0;
  args_info->virtual_netmask_given = 0;
  args_info->virtual_broadcast_given = 0;
  args_info->group_given = 0;
  args_info->priority_given = 0;
  args_info->log_given = 0;
  args_info->hello_time_given = 0;
  args_info->debug_given = 0;
#define clear_args() { \
  args_info->virtual_if_arg = NULL; \
  args_info->virtual_ip_arg = NULL; \
  args_info->virtual_netmask_arg = NULL; \
  args_info->virtual_broadcast_arg = NULL; \
  args_info->log_arg = NULL; \
}

  clear_args ();

  optarg = 0;
  optind = 1;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
	{"help", 0, NULL, 'h'},
	{"version", 0, NULL, 'V'},
	{"virtual-if", 1, NULL, 'i'},
	{"virtual-ip", 1, NULL, 'a'},
	{"virtual-netmask", 1, NULL, 'n'},
	{"virtual-broadcast", 1, NULL, 'b'},
	{"group", 1, NULL, 'g'},
	{"priority", 1, NULL, 'p'},
	{"log", 1, NULL, 'l'},
	{"hello-time", 1, NULL, 't'},
	{"debug", 0, NULL, 'd'},
	{NULL, 0, NULL, 0}
      };

      stop_char = 0;
      c =
	getopt_long (argc, argv, "hVi:a:n:b:g:p:l:t:d", long_options,
		     &option_index);

      if (c == -1)
	break;			/* Exit from `while (1)' loop.  */

      switch (c)
	{
	case 'h':		/* Print help and exit.  */
	  clear_args ();
	  cmdline_parser_print_help ();
	  exit (EXIT_SUCCESS);

	case 'V':		/* Print version and exit.  */
	  clear_args ();
	  cmdline_parser_print_version ();
	  exit (EXIT_SUCCESS);

	case 'i':		/* virtual interface.  */
	  if (args_info->virtual_if_given)
	    {
	      fprintf (stderr,
		       "%s: `--virtual-if' (`-i') option given more than once\n",
		       CMDLINE_PARSER_PACKAGE);
	      clear_args ();
	      exit (EXIT_FAILURE);
	    }
	  args_info->virtual_if_given = 1;
	  args_info->virtual_if_arg = gengetopt_strdup (optarg);
	  break;

	case 'a':		/* your virtual gateway ip address.  */
	  if (args_info->virtual_ip_given)
	    {
	      fprintf (stderr,
		       "%s: `--virtual-ip' (`-a') option given more than once\n",
		       CMDLINE_PARSER_PACKAGE);
	      clear_args ();
	      exit (EXIT_FAILURE);
	    }
	  args_info->virtual_ip_given = 1;
	  args_info->virtual_ip_arg = gengetopt_strdup (optarg);
	  break;

	case 'n':		/* virtual interface netmask.  */
	  if (args_info->virtual_netmask_given)
	    {
	      fprintf (stderr,
		       "%s: `--virtual-netmask' (`-n') option given more than once\n",
		       CMDLINE_PARSER_PACKAGE);
	      clear_args ();
	      exit (EXIT_FAILURE);
	    }
	  args_info->virtual_netmask_given = 1;
	  args_info->virtual_netmask_arg = gengetopt_strdup (optarg);
	  break;

	case 'b':		/* virtual interface broadcast address.  */
	  if (args_info->virtual_broadcast_given)
	    {
	      fprintf (stderr,
		       "%s: `--virtual-broadcast' (`-b') option given more than once\n",
		       CMDLINE_PARSER_PACKAGE);
	      clear_args ();
	      exit (EXIT_FAILURE);
	    }
	  args_info->virtual_broadcast_given = 1;
	  args_info->virtual_broadcast_arg = gengetopt_strdup (optarg);
	  break;

	case 'g':		/* vgp group.  */
	  if (args_info->group_given)
	    {
	      fprintf (stderr,
		       "%s: `--group' (`-g') option given more than once\n",
		       CMDLINE_PARSER_PACKAGE);
	      clear_args ();
	      exit (EXIT_FAILURE);
	    }
	  args_info->group_given = 1;
	  args_info->group_arg = strtol (optarg, &stop_char, 0);
	  break;

	case 'p':		/* vgp priority.  */
	  if (args_info->priority_given)
	    {
	      fprintf (stderr,
		       "%s: `--priority' (`-p') option given more than once\n",
		       CMDLINE_PARSER_PACKAGE);
	      clear_args ();
	      exit (EXIT_FAILURE);
	    }
	  args_info->priority_given = 1;
	  args_info->priority_arg = strtol (optarg, &stop_char, 0);
	  break;

	case 'l':		/* syslog facility.  */
	  if (args_info->log_given)
	    {
	      fprintf (stderr,
		       "%s: `--log' (`-l') option given more than once\n",
		       CMDLINE_PARSER_PACKAGE);
	      clear_args ();
	      exit (EXIT_FAILURE);
	    }
	  args_info->log_given = 1;
	  args_info->log_arg = gengetopt_strdup (optarg);
	  break;

	case 't':		/* vgp hello-time.  */
	  if (args_info->hello_time_given)
	    {
	      fprintf (stderr,
		       "%s: `--hello-time' (`-t') option given more than once\n",
		       CMDLINE_PARSER_PACKAGE);
	      clear_args ();
	      exit (EXIT_FAILURE);
	    }
	  args_info->hello_time_given = 1;
	  args_info->hello_time_arg = strtol (optarg, &stop_char, 0);
	  break;

	case 'd':		/* debug.  */
	  if (args_info->debug_given)
	    {
	      fprintf (stderr,
		       "%s: `--debug' (`-d') option given more than once\n",
		       CMDLINE_PARSER_PACKAGE);
	      clear_args ();
	      exit (EXIT_FAILURE);
	    }
	  args_info->debug_given = 1;
	  break;


	case 0:		/* Long option with no short option */

	case '?':		/* Invalid option.  */
	  /* `getopt_long' already printed an error message.  */
	  exit (EXIT_FAILURE);

	default:		/* bug: option not considered.  */
	  fprintf (stderr, "%s: option unknown: %c\n", CMDLINE_PARSER_PACKAGE,
		   c);
	  abort ();
	}			/* switch */
    }				/* while */


  if (!args_info->virtual_ip_given)
    {
      fprintf (stderr, "%s: '--virtual-ip' ('-a') option required\n",
	       CMDLINE_PARSER_PACKAGE);
      missing_required_options = 1;
    }
  if (missing_required_options)
    exit (EXIT_FAILURE);

  return 0;
}
